package org.artifactory.addon.artifact.lifecycle;

import org.artifactory.addon.Addon;
import org.artifactory.addon.license.EdgeBlockedAddon;
import org.artifactory.addon.license.EnterprisePlusAddon;
import org.artifactory.addon.release.bundle.ReleaseBundleAddon;
import org.artifactory.api.rest.artifact.lifecycle.ArtifactLifecycleColdRestoreRequest;
import org.artifactory.api.rest.artifact.lifecycle.ArtifactLifecycleRestoreRequest;
import org.artifactory.aql.result.AqlRestResult;
import org.artifactory.descriptor.artifact.lifecycle.ArtifactLifecyclePolicyDescriptor;
import org.artifactory.storage.StorageSummary;
import org.artifactory.util.UnsupportedByLicenseException;

import java.io.IOException;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * @author Tamar Rosen
 */
@EdgeBlockedAddon
@EnterprisePlusAddon
public interface ArtifactLifecycleAddon extends Addon {

    default void triggerPolicy(String policyKey) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default ArtifactLifecyclePolicyModel getPolicy(String policyKey) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default ArtifactLifecyclePolicyModel addPolicy(String policyKey, ArtifactLifecyclePolicyDescriptor policy) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default ArtifactLifecyclePolicyModel updatePolicy(String policyKey,
            ArtifactLifecyclePolicyDescriptor newPolicy) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default void deletePolicy(String policyKey) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default void restore(ArtifactLifecycleRestoreRequest restoreRequest) throws IOException {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default void executeColdRestore(ArtifactLifecycleColdRestoreRequest coldRestoreRequest) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default Map<String, String> getCreateBinaryHeaders() {
        return Collections.emptyMap();
    }

    default Map<String, String> getInitiateBinaryRestoreHeaders() {
        return Collections.emptyMap();
    }

    default Map<String, String> getIsBinaryRestoredHeaders() {
        return Collections.emptyMap();
    }

    default List<ArtifactLifecyclePolicyModel> getPolicies() {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default ArtifactLifecycleStats getArtifactLifecycleStats() {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default boolean isColdInstance() {
        return false;
    }

    default AqlRestResult searchOnColdInstance(String aqlStr) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default String generateJFrogColdStorageNamespace() {
        return null;
    }

    default void coldStorageHandshake() {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default String getJfrogColdStorageArchivingNamespace() {
        return null;
    }

    default List<ArtifactLifecycleArchivePolicyStatus> getArchivePoliciesExecutions(Long extractLongEpoch,
            Long extractLongEpoch1, String searchStr) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default List<ArtifactLifecycleRestorePolicyStatus> getRestorePoliciesExecutions(Long extractLongEpoch,
            Long extractLongEpoch1) {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    }

    default StorageSummary getArchiveStorageSummary() {
        throw new UnsupportedByLicenseException("Artifact Lifecycle " + ReleaseBundleAddon.ENTERPRISE_PLUS_MSG);
    };
}