package org.artifactory.addon.artifact.lifecycle;

import lombok.experimental.UtilityClass;
import org.artifactory.descriptor.artifact.lifecycle.ArtifactLifecyclePolicyDescriptor;

import java.util.Objects;

@UtilityClass
public class PolicyTranslator {
    public ArtifactLifecyclePolicyModel toPolicyModel(ArtifactLifecyclePolicyDescriptor policyDescriptor) {
        return ArtifactLifecyclePolicyModel.builder()
                .key(policyDescriptor.getKey())
                .description(policyDescriptor.getDescription())
                .cronExp(policyDescriptor.getCronExp())
                .aqlQuery(policyDescriptor.getAqlQuery())
                .durationInMinutes(policyDescriptor.getDurationInMinutes())
                .build();
    }

    public ArtifactLifecyclePolicyDescriptor toPolicyDescriptor(ArtifactLifecyclePolicyBaseModel policyModelBase,
            ArtifactLifecycleOperationType type) {
        ArtifactLifecyclePolicyDescriptor policyDescriptor = new ArtifactLifecyclePolicyDescriptor();
        policyDescriptor.setKey(policyModelBase.getKey());
        policyDescriptor.setDescription(policyModelBase.getDescription());
        policyDescriptor.setCronExp(policyModelBase.getCronExp());
        policyDescriptor.setAqlQuery(policyModelBase.getAqlQuery());
        policyDescriptor.setType(type.name());
        long policyDuration =
                Objects.isNull(policyModelBase.getDurationInMinutes()) ? 0 : policyModelBase.getDurationInMinutes();
        policyDescriptor.setDurationInMinutes(policyDuration);
        return policyDescriptor;
    }
}
