package org.artifactory.metrics;

public class MetricsThreadLocal {
    private static final ThreadLocal<MetricsThreadLocalContext> context = new ThreadLocal<>();

    private MetricsThreadLocal() {
    }

    public static void bind(MetricsMetadata metadata) {
        context.set(MetricsThreadLocalContext.create(metadata));
    }

    public static void unbind() {
        context.remove();
    }

    public static String getRepoName() {
        MetricsThreadLocalContext metricsThreadLocalContext = context.get();
        return metricsThreadLocalContext != null ? metricsThreadLocalContext.getMetricsThreadLocal().getRepoName() :
                null;
    }

    public static void setRepoName(String repoName) {
        MetricsThreadLocalContext metricsThreadLocalContext = context.get();
        if (metricsThreadLocalContext != null) {
            metricsThreadLocalContext.getMetricsThreadLocal().setRepoName(repoName);
        }
    }

    public static String getAction() {
        MetricsThreadLocalContext metricsThreadLocalContext = context.get();
        return metricsThreadLocalContext != null ? metricsThreadLocalContext.getMetricsThreadLocal().getAction() :
                null;
    }

    public static void setAction(String action) {
        MetricsThreadLocalContext metricsThreadLocalContext = context.get();
        if (metricsThreadLocalContext != null) {
            metricsThreadLocalContext.getMetricsThreadLocal().setAction(action);
        }
    }
}
