package org.artifactory.ui.rest.model.artifacts.browse.treebrowser.nodes;

import org.artifactory.descriptor.repo.FederatedRepoDescriptor;
import org.artifactory.descriptor.repo.LocalRepoDescriptor;
import org.testng.annotations.Test;

import static org.artifactory.ui.rest.model.artifacts.browse.treebrowser.nodes.RepositoryType.byDescriptor;
import static org.testng.Assert.assertEquals;

/**
 * @author Alexei Vainshtein
 */
public class RepositoryTypeTest {

    @Test
    public void testByDescriptor() {
        LocalRepoDescriptor localRepoDescriptor = new LocalRepoDescriptor();
        assertEquals(byDescriptor(localRepoDescriptor), RepositoryType.LOCAL);

        FederatedRepoDescriptor federatedRepoDescriptor = new FederatedRepoDescriptor();
        assertEquals(byDescriptor(federatedRepoDescriptor), RepositoryType.FEDERATED);
    }
}